/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

void snc_set_config_err(char *opt, char *val) {
	sprintf(err_msg, "Invalid value to option[%s]: <%s>", opt, val);
	snc_exit(1, err_msg);
}

void snc_set_config(char *opt, char *val) {

	if(strcmp(opt, "snort_conf") == 0) {
		if(val[0] != '\0') {
			strcpy(cf.snort_conf, val);
		} else {
			snc_set_config_err(opt, val);
		}
	
	} else if(strcmp(opt, "snort_rules") == 0)  {
		if(val[0] != '\0') {
			strcpy(cf.rulesdir, val);
		} else {
			snc_set_config_err(opt, val);
		}
	
	} else if(strcmp(opt, "snort_conf_dir") == 0) {
		if(val[0] != '\0') {
			strcpy(cf.snort_cfgdir, val);
		} else {
			snc_set_config_err(opt, val);
		}

	} else {
		sprintf(err_msg, "Invalid option [%s] in rules file", opt);
		snc_exit(1, err_msg);
	}
	
	return;
}

/* Read snort-conf config file and set var's accordingly	*/
int snc_read_snc_config() {
        char line[1024];
        char opt[256];
        char val[256];
        FILE *cfgfile;

        cfgfile = fopen(cf.configfile, "r");
	if(cfgfile == 0) {
		sprintf(err_msg, "Unable to open snortconf config file: %s", cf.configfile);
		snc_exit (1, err_msg);
        }
        while(fgets(line, 1023, cfgfile) != NULL) {
                if(snc_regex(line, ".*=.*") == TRUE && snc_regex(line, "#") != TRUE) {
                        strcpy(val, "\0");
                        strcpy(opt, "\0");

                        sscanf(line, "%[^=]", opt);
                        sscanf(line, "%*[^=]=%s", val);
                        snc_set_config(opt, val);
                }
        }
        fclose(cfgfile);
	return 0;
}

