/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* Use GNU regex's to see if we have a match. */
int snc_regex(char *string, char *pattern) {
        /*      Someplace to compile our regex into */
        regex_t    regex_compiled;

        /* If we can't compile our regex, return error */
        if (regcomp(&regex_compiled, pattern, REG_EXTENDED|REG_NOSUB|REG_ICASE) != 0) {
                return(FALSE);      /* report error */
        }

        /* If we don't get a match, return error */
        if (regexec(&regex_compiled, string, (size_t) 0, NULL, 0) != 0) {
                regfree(&regex_compiled);
                return(FALSE);      /* report error */
        }

         return(TRUE);
}

