/*
 *   snortconf - configuration tool for snort.conf
 *
 *   Copyright (C) 2001 ManISec, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Yee ole includes (I put this all in one file for my sanity) */
#include "include.h"

/* dumbass little wrapper for glob() */
glob_t a_find(char *findme) {

          glob_t globbuf;

          globbuf.gl_offs = 2;
          glob(findme, GLOB_DOOFFS, NULL, &globbuf);
          return globbuf;

}


/* set yee ole variables to sane things to start with */
void vars_sanity() {
	unsigned long int i;
	
	plug.frag2 = TRUE;
        plug.stream4 = TRUE;
        plug.stream4_reass = FALSE;
        plug.http_decode = TRUE;
        plug.unidecode = FALSE;
        plug.rpc_decode = TRUE;
        plug.bo_detect = FALSE;
        plug.telnet_decode = TRUE;
        plug.spade = FALSE;
        plug.arp_spoof = FALSE;
        plug.arp_detect_host = FALSE;
        plug.portscan = FALSE;
	/* default logdir			*/
	strcpy(cfg.logdir, "/var/log/snort");
	
	output.syslog = TRUE;
	output.tcpdump = TRUE;
        /* look through yee ole available rules files and disable a few we know to be 'chatty' by default */
	for(i = rules_files.gl_offs; i < rules_files.gl_pathc; ++i) {
		if(snc_regex(rules_files.gl_pathv[i], "backdoor.rules|ddos.rules|icmp-info.rules|icmp.rules|info.rules|misc.rules|policy.rules|scan.rules") != TRUE) {
			rules_idx[i] = TRUE;
		}
	}
	/* some variables which should be set before we enter the program proper	*/
	strcpy(var.http_ports, "80");
	strcpy(var.oracle_ports, "1521");
	strcpy(var.shellcode_ports, "!80");
}

/* Initialize things to sane defaults */
int snc_init(int argc, char **argv) {
	/* in getopts we read yee ole snortconf/sc.cf config file	*/
	if(snc_getopts(argc, argv) != TRUE) {
		snc_exit(0, NULL);
	}
	
	cfg_basic = TRUE; 		/* don't have advanced config written yet */

	/* call this guy first before sanity function!!! */
	rules_files = a_find(cf.rulesdir);
	vars_sanity();	  
	/* ncurses init */
	curs_init();
	
	return 0;
}

/* yee ole cleanup function to call before exiting.  Really should write some signal.h code to
 trap a forced exit and call this so screen doesn't get corrupted */
int snc_cleanup() {
	endwin();
	return 0;
}
